import {EntityRepository, Repository} from "typeorm";
import {UpdatePageMetaCmsDto} from "./dto/update-page-meta-cms.dto";
import {PageMetaCmsEntity} from "./entities/page-meta-cms.entity";

@EntityRepository(PageMetaCmsEntity)
export class PageMetaCmsRepository extends Repository<PageMetaCmsEntity> {

    async createEntity(dto: UpdatePageMetaCmsDto): Promise<PageMetaCmsEntity | Error> {
        try {
            const entity = this.create({
                signinPageMetaKeyword: dto.signinPageMetaKeyword,
                signinPageMetaDescription: dto.signinPageMetaDescription,
                signupPageMetaKeyword: dto.signupPageMetaKeyword,
                signupPageMetaDescription: dto.signupPageMetaDescription,
                homePageMetaKeyword: dto.homePageMetaKeyword,
                homePageMetaDescription: dto.homePageMetaDescription,
                shopPageMetaKeyword: dto.shopPageMetaKeyword,
                shopPageMetaDescription: dto.shopPageMetaDescription,
                productDetailsPageMetaKeyword: dto.productDetailsPageMetaKeyword,
                productDetailsPageMetaDescription: dto.productDetailsPageMetaDescription,
                wishlistPageMetaKeyword: dto.wishlistPageMetaKeyword,
                wishlistPageMetaDescription: dto.wishlistPageMetaDescription,
                cartPageMetaKeyword: dto.cartPageMetaKeyword,
                cartPageMetaDescription: dto.cartPageMetaDescription,
                aboutUsPageMetaKeyword: dto.aboutUsPageMetaKeyword,
                aboutUsPageMetaDescription: dto.aboutUsPageMetaDescription,
                categoriesPageMetaKeyword: dto.categoriesPageMetaKeyword,
                categoriesPageMetaDescription: dto.categoriesPageMetaDescription,
                brandPageMetaKeyword: dto.brandPageMetaKeyword,
                brandPageMetaDescription: dto.brandPageMetaDescription,
                specialsPageMetaKeyword: dto.specialsPageMetaKeyword,
                specialsPageMetaDescription: dto.specialsPageMetaDescription,
                locationPageMetaKeyword: dto.locationPageMetaKeyword,
                locationPageMetaDescription: dto.locationPageMetaDescription,
                contactUsPageMetaKeyword: dto.contactUsPageMetaKeyword,
                contactUsPageMetaDescription: dto.contactUsPageMetaDescription,
                faqPageMetaKeyword: dto.faqPageMetaKeyword,
                faqPageMetaDescription: dto.faqPageMetaDescription,
                careerPageMetaKeyword: dto.careerPageMetaKeyword,
                careerPageMetaDescription: dto.careerPageMetaDescription,
                careerDepartmentPageMetaKeyword: dto.careerDepartmentPageMetaKeyword,
                careerDepartmentPageMetaDescription: dto.careerDepartmentPageMetaDescription,
                careerDetailsPageMetaKeyword: dto.careerDetailsPageMetaKeyword,
                careerDetailsPageMetaDescription: dto.careerDetailsPageMetaDescription,
                blogPageMetaKeyword: dto.blogPageMetaKeyword,
                blogPageMetaDescription: dto.blogPageMetaDescription,
                blogDetailsPageMetaKeyword: dto.blogDetailsPageMetaKeyword,
                blogDetailsPageMetaDescription: dto.blogDetailsPageMetaDescription,
                privacyPageMetaKeyword: dto.privacyPageMetaKeyword,
                privacyPageMetaDescription: dto.privacyPageMetaDescription,
                termsPageMetaKeyword: dto.termsPageMetaKeyword,
                termsPageMetaDescription: dto.termsPageMetaDescription,
                profilePageMetaKeyword: dto.profilePageMetaKeyword,
                profilePageMetaDescription: dto.profilePageMetaDescription,
                successPageMetaKeyword: dto.successPageMetaKeyword,
                successPageMetaDescription: dto.successPageMetaDescription,
                retailerPageMetaKeyword: dto.retailerPageMetaKeyword,
                retailerPageMetaDescription: dto.retailerPageMetaDescription,
                forgotPasswordPageMetaKeyword: dto.forgotPasswordPageMetaKeyword,
                forgotPasswordPageMetaDescription: dto.forgotPasswordPageMetaDescription,
                choosePlacePageMetaKeyword: dto.choosePlacePageMetaKeyword,
                choosePlacePageMetaDescription: dto.choosePlacePageMetaDescription,
                resetPasswordPageMetaKeyword: dto.resetPasswordPageMetaKeyword,
                resetPasswordPageMetaDescription: dto.resetPasswordPageMetaDescription,
                invoicePageMetaKeyword: dto.invoicePageMetaKeyword,
                invoicePageMetaDescription: dto.invoicePageMetaDescription,
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async UpdateEntity(dto: UpdatePageMetaCmsDto, id: string): Promise<PageMetaCmsEntity | Error> {
        try {
            await this.update(id, {
                signinPageMetaKeyword: dto.signinPageMetaKeyword,
                signinPageMetaDescription: dto.signinPageMetaDescription,
                signupPageMetaKeyword: dto.signupPageMetaKeyword,
                signupPageMetaDescription: dto.signupPageMetaDescription,
                homePageMetaKeyword: dto.homePageMetaKeyword,
                homePageMetaDescription: dto.homePageMetaDescription,
                shopPageMetaKeyword: dto.shopPageMetaKeyword,
                shopPageMetaDescription: dto.shopPageMetaDescription,
                productDetailsPageMetaKeyword: dto.productDetailsPageMetaKeyword,
                productDetailsPageMetaDescription: dto.productDetailsPageMetaDescription,
                wishlistPageMetaKeyword: dto.wishlistPageMetaKeyword,
                wishlistPageMetaDescription: dto.wishlistPageMetaDescription,
                cartPageMetaKeyword: dto.cartPageMetaKeyword,
                cartPageMetaDescription: dto.cartPageMetaDescription,
                aboutUsPageMetaKeyword: dto.aboutUsPageMetaKeyword,
                aboutUsPageMetaDescription: dto.aboutUsPageMetaDescription,
                categoriesPageMetaKeyword: dto.categoriesPageMetaKeyword,
                categoriesPageMetaDescription: dto.categoriesPageMetaDescription,
                brandPageMetaKeyword: dto.brandPageMetaKeyword,
                brandPageMetaDescription: dto.brandPageMetaDescription,
                specialsPageMetaKeyword: dto.specialsPageMetaKeyword,
                specialsPageMetaDescription: dto.specialsPageMetaDescription,
                locationPageMetaKeyword: dto.locationPageMetaKeyword,
                locationPageMetaDescription: dto.locationPageMetaDescription,
                contactUsPageMetaKeyword: dto.contactUsPageMetaKeyword,
                contactUsPageMetaDescription: dto.contactUsPageMetaDescription,
                faqPageMetaKeyword: dto.faqPageMetaKeyword,
                faqPageMetaDescription: dto.faqPageMetaDescription,
                careerPageMetaKeyword: dto.careerPageMetaKeyword,
                careerPageMetaDescription: dto.careerPageMetaDescription,
                careerDepartmentPageMetaKeyword: dto.careerDepartmentPageMetaKeyword,
                careerDepartmentPageMetaDescription: dto.careerDepartmentPageMetaDescription,
                careerDetailsPageMetaKeyword: dto.careerDetailsPageMetaKeyword,
                careerDetailsPageMetaDescription: dto.careerDetailsPageMetaDescription,
                blogPageMetaKeyword: dto.blogPageMetaKeyword,
                blogPageMetaDescription: dto.blogPageMetaDescription,
                blogDetailsPageMetaKeyword: dto.blogDetailsPageMetaKeyword,
                blogDetailsPageMetaDescription: dto.blogDetailsPageMetaDescription,
                privacyPageMetaKeyword: dto.privacyPageMetaKeyword,
                privacyPageMetaDescription: dto.privacyPageMetaDescription,
                termsPageMetaKeyword: dto.termsPageMetaKeyword,
                termsPageMetaDescription: dto.termsPageMetaDescription,
                profilePageMetaKeyword: dto.profilePageMetaKeyword,
                profilePageMetaDescription: dto.profilePageMetaDescription,
                successPageMetaKeyword: dto.successPageMetaKeyword,
                successPageMetaDescription: dto.successPageMetaDescription,
                retailerPageMetaKeyword: dto.retailerPageMetaKeyword,
                retailerPageMetaDescription: dto.retailerPageMetaDescription,
                forgotPasswordPageMetaKeyword: dto.forgotPasswordPageMetaKeyword,
                forgotPasswordPageMetaDescription: dto.forgotPasswordPageMetaDescription,
                choosePlacePageMetaKeyword: dto.choosePlacePageMetaKeyword,
                choosePlacePageMetaDescription: dto.choosePlacePageMetaDescription,
                resetPasswordPageMetaKeyword: dto.resetPasswordPageMetaKeyword,
                resetPasswordPageMetaDescription: dto.resetPasswordPageMetaDescription,
                invoicePageMetaKeyword: dto.invoicePageMetaKeyword,
                invoicePageMetaDescription: dto.invoicePageMetaDescription,
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<PageMetaCmsEntity[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}