import {Module} from '@nestjs/common';
import {TypeOrmModule} from '@nestjs/typeorm';
import {JwtModule} from '@nestjs/jwt';
import JwtConfigService from 'src/core/jwt/jwt-config.service';
import JwtHelper from 'src/core/jwt/jwt.helper';
import {UsersRepository} from 'src/modules/users/user.repository';
import {FileUploadsService} from 'src/modules/file-uploads/file-uploads.service';
import {PageTitleCmsRepository} from './page-title-cms.repository';
import {PageTitleCmsController} from './page-title-cms.controller';
import {PageTitleCmsService} from './page-title-cms.service';

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([UsersRepository]),
        TypeOrmModule.forFeature([PageTitleCmsRepository])
    ],
    controllers: [PageTitleCmsController],
    providers: [PageTitleCmsService, JwtHelper, FileUploadsService]
})
export class PageTitleCmsModule {
}