import {Module} from "@nestjs/common";
import {TypeOrmModule} from "@nestjs/typeorm";
import {JwtModule} from "@nestjs/jwt";
import JwtConfigService from "src/core/jwt/jwt-config.service";
import JwtHelper from "src/core/jwt/jwt.helper";
import {UsersRepository} from "src/modules/users/user.repository";
import {FileUploadsService} from "src/modules/file-uploads/file-uploads.service";
import {DoSpacesService} from "src/modules/SpacesModule/SpacesService/doSpacesService";
import {DoSpacesServicerovider} from "src/modules/SpacesModule/SpacesService";
import { CareerDepartmentPageComponentUiRepository } from "./career-department-page-component-ui.repository";
import { CareerDepartmentPageComponentUiController } from "./career-department-page-component-ui.controller";
import { CareerDepartmentPageComponentUiService } from "./career-department-page-component-ui.service";

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([UsersRepository]),
        TypeOrmModule.forFeature([CareerDepartmentPageComponentUiRepository])
    ],
    controllers: [CareerDepartmentPageComponentUiController],
    providers: [CareerDepartmentPageComponentUiService, JwtHelper, FileUploadsService, DoSpacesService, DoSpacesServicerovider]
})
export class CareerDepartmentPageComponentUiModule {}