import { EntityRepository, Repository } from "typeorm";
import { CareerDetailsPageComponentUiEntity } from "./entities/career-details-page-component-ui.entity";
import { UpdateCareerDetailsPageComponentUiDto } from "./dto/update-career-details-page-component-ui.dto";

@EntityRepository(CareerDetailsPageComponentUiEntity)
export class CareerDetailsPageComponentUiRepository extends Repository<CareerDetailsPageComponentUiEntity> {

    async createEntity(dto: UpdateCareerDetailsPageComponentUiDto): Promise<CareerDetailsPageComponentUiEntity | Error> {
        try {
            const entity = this.create({
                backgroundColor: dto.backgroundColor,
                sectionTwoTitleFontColor: dto.sectionTwoTitleFontColor,
                sectionThreeTitleFontColor: dto.sectionThreeTitleFontColor
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateCareerDetailsPageComponentUiDto, id: string): Promise<CareerDetailsPageComponentUiEntity | Error> {
        try {
            await this.update(id, {
                backgroundColor: dto.backgroundColor,
                sectionTwoTitleFontColor: dto.sectionTwoTitleFontColor,
                sectionThreeTitleFontColor: dto.sectionThreeTitleFontColor
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<CareerDetailsPageComponentUiEntity[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}