import {Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards} from "@nestjs/common";
import {AdminAuthGuard} from "src/core/guards/admin-auth.guard";
import {Constants} from "src/utils/constants";
import { FaqPageComponentUiService } from "./faq-page-component-ui.service";
import { UpdateFaqPageComponentUiDto } from "./dto/update-faq-page-component-ui.dto";

@Controller({path: "faq-page-component-ui", version: Constants.API_VERSION_1})

export class FaqPageComponentUiController {
    constructor(private readonly service: FaqPageComponentUiService) {}

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(
        @Body() dto: UpdateFaqPageComponentUiDto
    ) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    // @UseGuards(AdminAuthGuard)
    findAll() {
        return this.service.findAll();
    }
}
